/*
 * Simple exemple d'utilisation des smaphores en C sous Linux.
 * Montre comment crer le smaphore, l'initialiser, faire des 
 * oprations P() et V(), et enfin, dtruire le smaphore.
 */
#include	<sys/types.h>
#include	<sys/ipc.h>
#include	<sys/sem.h>
#include	<sys/stat.h>
#include	<stdio.h>
#include	<stdlib.h>

#define	MA_CLE	1234

int	main()
{
	int		s;
	/* Constante sur les smaphores */
	struct sembuf	operation_P = { 0, -1, 0 };
	struct sembuf	operation_V = { 0, 1, 0 };
	/*
	  * Autre solution pour initialiser les oprations : 
	  * struct sembuf	operation_P, operation_V;
	  * operation_P.sem_num = 0; 
	  * operation_P.sem_op = -1;
	  * operation_P.sem_flg = 0;
	  * operation_V.sem_num = 0; 
	  * operation_V.sem_op = 1;
	  * operation_V.sem_flg = 0;
	  */

	  /* Creation de l'IPC */
	s = semget(MA_CLE, 1, IPC_CREAT|S_IRUSR|S_IWUSR);
	if (s < 0)
	{
		fprintf(stderr, "semget() erreur.\n");
		exit(-1);
	}
	semctl(s, 0, SETVAL, 1); /* Init(s, 1); */
	
	/* Bla bla bla */
	/* L'objet critique n'est pas protg */	
	/* Bla bla bla */

	semop(s, &operation_P, 1); /* P(s); */
	
	/* L'objet critique est protg, on peut l'utiliser */
	/* Bla bla bla */

	semop(s, &operation_V, 1); /* V(s); */

	/* L'objet critique n'est plus protg */
	
	/* On peut dtruire le smaphore */
	semctl(s, 0, IPC_RMID, 0);
	
	return(0);
}
